#!/usr/bin/env python3

__author__ = "DFIRSec (@pulsecode)"
__description__ = "Extract Indicators of Compromise (IOCs) from PDF documents."

import re

from pdfiocrex import regex


def processor(regex, text):
    return [x.group() for x in re.finditer(regex, text)]

def patts(text):
    patterns = {
        'ARABIC': processor(regex(_type='arabic'), text),
        'ARCHIVE': processor(regex(_type='archive'), text),
        'BINARY': processor(regex(_type='binary'), text),
        'BTC': processor(regex(_type='btc'), text),
        'CHINESE': processor(regex(_type='chinese'), text),
        'CYRILLIC': processor(regex(_type='cyrillic'), text),
        'DOMAIN': processor(regex(_type='domain'), text),
        'EMAIL': processor(regex(_type='email'), text),
        'ENVIRONMENT VARIABLE': processor(regex(_type='env_var'), text),
        'MISC FILE': processor(regex(_type='misc_file'), text),
        'IMAGE': processor(regex(_type='image'), text),
        'IPV4': processor(regex(_type='ipv4'), text),
        'MD5': processor(regex(_type='md5'), text),
        'OFFICE/PDF': processor(regex(_type='office'), text),
        'PHONE': processor(regex(_type='phone'), text),
        'SCRIPT': processor(regex(_type='script'), text),
        'SHA1': processor(regex(_type='sha1'), text),
        'SHA256': processor(regex(_type='sha256'), text),
        'URL': processor(regex(_type='url'), text),
        'WEB FILE': processor(regex(_type='webfile'), text),
        'WIN DIR': processor(regex(_type='windir'), text)
    }
    
    return patterns
